The pipeline is shown in the following diagram: 
------ 


![image info](pipeline.png)


#### Download Prerequisites
 
The first stage of the pipeline is download_prerequisites stage. The purpose is to download all the artifacts needed for later stages. these artifacts are basically shell scripts and python scripts for various purposes.

considering the lkft common, the following scripts are needed: 
-  `build-afterscript.sh`
-  `build-email.py`
-  `gen-report.sh`
-  `gen-report-extra.sh`
-  `gen-review.sh`
- `gen-variables.sh`
-  `get-artifacts.sh`
-  `register-callback.sh`
-  `send-email.py`
- `squad-client-cup.sh`
- `submit-jobs-to-bisect.sh`

and if SQUAD_REPORT_CONFIG is enabled, then it also downloads the squad-report-config.yml. 
Then all scripts are made executable. 

This stage doesn't run if both run_sanity and run_test are not enabled in the pipeline. 
It uses the curl docker image, to run curl command to download all artifacts. 

#### Prerequisites
----
This stage performs the necessary checking for the project inputs and artifacts that are downloaded in the previous stage, to make sure inputs are ready. 
it has multiple components: 
###### validate inputs 
This stage uses the DebianBuster slim Docker image. it performs the following checks: 
- repository name
- kernel repository
- kernel branch
- latest sha.

the outcomes of this is an `inputs.sh` shell script file. 


##### check project
This step requires the prerquisites to have been downloaded successfully. This is because it uses the `squad-client-cup.sh` script to run a squad-client command given the available environment variables set about the project, and checks the sanity of the project. 
it requires a squad image `squadproject/squad-client:0.14` as it runs a squad client command. 

##### verify tag

This checks the kernel GPG key fingerprints in the kernel/pgpkeys repo. it uses the debian-buster slim docker image. 
it runs the git tag command on the supplied CI_COMMIT_TAG variable. 


#### Build
--------
This stage builds the kernel images. it uses the tuxsuite build-set commadn and supplies all required parameter values that are stored in environment variables. these parameters are:
- git-repo 
- git-sha 
- tux-config file 
- build set name 
- output json file 

it runs on a tuxsuite docker image : `tuxsuite/tuxsuite:0.25.0`
after the build finishes, and the `build.json` is produced, the stage runs the script `build-afterscript.sh`. 
- Extracts the git-description from the build.json file and sets it as an environment variable. 
- Installs squad-client. 
- Uses squad-client to submit a tuxsuite build result. 
- submits anothre tuxsuite build result to the sanity project, if enabled. 
- Sumbits job to bisection if it enabled. 


#### Test
--------
The way this stage is defined is by inheriting from the `.submit_test` in the yaml file which defines most of the requirement, but add to it the rules specifing when to run, and whether the run is manual or not. it also overrides the stage description or the `.submit_test` from sanity to test. 
The test stage relies on the LAVA software to submit tests. This uses the docker image `lavasoftware/lava-test-plans:v3.1`. 

TODO: check where is the submit-tests.sh located. couldn't find it in the repository and is not generated from the previous stage. 



#### Sanity test
--------
Similar to the test stage, it inherits from the `.submit_test` and adds rules to whether to run sanity or not based on the input parameters,, and specifies LAVA config variables : 
- lava job priority, default to 80. 
- lava tests to run : ltp-smoketests 



#### Review
--------
This uses a python docker image `python:3.8-slim-buster` for this task. it generates the review.txt file, and sends an email. 
the `review.txt` file is generated by running the `gen-review.sh` and the email is sent using the `send-email.py`, both downloaded at the download prerequisites stage. 

The `gen-review.sh` builds the email content by specifying the sender, receivers (to and cc),  and sets the message body to the report txt content. it stores the email body in the `review.txt` file. 


#### Report
--------
Similar to the review stage, it uses a python image, `python:3.8-slim-buster`, and runs when both the test and the sanity stages are run. 
it runs the squad-report command for all specified report types in the `SQUAD_REPORTS` variable. This is done using the `gen-report.sh` file generated at the first stage, and the squad report config yaml file collected using `get-artifacts.sh`. 
The `get-artifacts.sh` script downloads all the job artifacts in a zip file in addition to the `build.json` file. 
The squad-report command is ran using the script `gen-report.sh`. 

#### Upstream
--------
runs the `send-email.py` python script on a `python:3.8-slim-buster` docker image. This stage is not run if both the sanity and test stage have not been run. 

